Attribute VB_Name = "2"
Public Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type RGB
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
End Type

Public Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Public Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type

Public Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

Public bi24BitInfo As BITMAPINFO
Public bBytes(1 To 196608) As Byte
Public App_Name As String

Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0

Public Sub FillPallete(Picture As PictureBox, usecolor As RGB)
Dim Cnt As Long: Dim xc As Long: Dim yc As Long
Dim color As RGB
For xc = 0 To 255
    For yc = 0 To 255
        color.rgbRed = (0 * yc + ((255 * xc + usecolor.rgbRed * (255 - xc)) \ 255) * (255 - yc)) \ 255
        color.rgbGreen = (0 * yc + ((255 * xc + usecolor.rgbGreen * (255 - xc)) \ 255) * (255 - yc)) \ 255
        color.rgbBlue = (0 * yc + ((255 * xc + usecolor.rgbBlue * (255 - xc)) \ 255) * (255 - yc)) \ 255
        GFX_SET_PIXEL_DIB bBytes, xc, yc, color, bi24BitInfo.bmiHeader.biWidth
    Next yc
Next xc
SetDIBitsToDevice Picture.hdc, 0, 0, bi24BitInfo.bmiHeader.biWidth, bi24BitInfo.bmiHeader.biHeight, 0, 0, 0, bi24BitInfo.bmiHeader.biHeight, bBytes(1), bi24BitInfo, DIB_RGB_COLORS
End Sub

Public Sub GFX_SET_PIXEL_DIB(ByRef obj() As Byte, ByVal sX As Long, ByVal sY As Long, zColor As RGB, hWidth As Long)
    Dim dibX As Long, dibY As Long
    Dim cNum As Long
    
    dibX = sX + 1: dibY = hWidth - sY
    cNum = (hWidth * (dibY - 1) + dibX) * 3 - 2
    
    obj(cNum) = zColor.rgbBlue
    obj(cNum + 2) = zColor.rgbRed
    obj(cNum + 1) = zColor.rgbGreen
End Sub

Public Function GetRGB(ByVal ColorVal As Long, Result As RGB) As Boolean
    Result.rgbRed = ColorVal And 255
    Result.rgbGreen = (ColorVal And 65535) \ 256
    Result.rgbBlue = ColorVal \ 65536
End Function

Public Sub FillSpectre(Picture As PictureBox)
Dim NewRed As Byte
Dim NewGreen As Byte
Dim NewBlue As Byte
Dim x As Long: Dim y As Long
Picture.Cls
For x = 1 To 15
    For y = 1 To 42
        SetPixel Picture.hdc, x - 1, y - 1, RGB(255, 0, 255 / (42.5 / y))
    Next y
Next x
For x = 1 To 15
    For y = 1 To 42
        SetPixel Picture.hdc, x - 1, 42 + y - 1, RGB(255 - (255 / (42.5 / y)), 0, 255)
    Next y
Next x
For x = 1 To 15
    For y = 1 To 42
        SetPixel Picture.hdc, x - 1, 84 + y - 1, RGB(0, 255 / (42.5 / y), 255)
    Next y
Next x
For x = 1 To 15
    For y = 1 To 42
        SetPixel Picture.hdc, x - 1, 126 + y - 1, RGB(0, 255, 255 - (255 / (42.5 / y)))
    Next y
Next x
For x = 1 To 15
    For y = 1 To 42
        SetPixel Picture.hdc, x - 1, 168 + y - 1, RGB(255 / (42.5 / y), 255, 0)
    Next y
Next x
For x = 1 To 15
    For y = 1 To 42
        SetPixel Picture.hdc, x - 1, 210 + y - 1, RGB(255, 255 - (255 / (42.5 / y)), 0)
    Next y
Next x
End Sub
